
::CW_Stats_GiantHeavyIronCurtain <- function(weapon, player)
{
	weapon.AddAttribute("damage bonus", 2, -1)
	weapon.AddAttribute("projectile penetration heavy", 3, -1)
	weapon.AddAttribute("pyro year number", 3, -1)
	weapon.AddAttribute("fire rate bonus with reduced health", 0.3, -1)
	weapon.AddAttribute("minigun spinup time decreased", 0.8, -1)
	weapon.AddAttribute("spunup_damage_resistance", 0.8, -1)
	weapon.AddAttribute("mod shovel damage boost", 1, -1)
	weapon.AddAttribute("selfmade description", 1, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyNormal <- function(weapon, player)
{
    weapon.AddAttribute("damage bonus", 1.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyDeflecter <- function(weapon, player)
{
    weapon.AddAttribute("attack projectiles", 4, -1)
    weapon.AddAttribute("damage bonus", 1.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyHuoLongHeatmaker <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("Set DamageType Ignite", 1, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyHuoLongHeatmaker <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("Set DamageType Ignite", 1, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroFlamethrower <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("airblast cost increased", 2, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("airblast pushback scale", 2, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroNapalmer <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("airblast disabled", 1, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("weapon burn dmg increased", 4, -1)
	weapon.AddAttribute("weapon burn time increased", 2, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantEngineerPomson <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("damage bonus", 3, -1)
	weapon.AddAttribute("projectile speed increased", 8, -1)
}

::CW_Stats_GiantEngineerWidowmaker <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 1.5, -1)
	weapon.AddAttribute("faster reload rate", 0.8, -1)
	weapon.AddAttribute("weapon spread bonus", 1.4, -1)
	weapon.AddAttribute("damage penalty", 1.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantScoutForceANature <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.5, -1)
	weapon.AddAttribute("bullets per shot bonus", 2, -1)
	weapon.AddAttribute("faster reload rate", 1.7, -1)
	weapon.AddAttribute("scattergun knockback mult", 6, -1)
	weapon.AddAttribute("weapon spread bonus", 0.4, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	//weapon.AddAttribute("auto fires full clip", 1, -1)//31.21875
	weapon.AddAttribute("hidden primary max ammo bonus", 31.21875, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroManmelter <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("override projectile type", 13, -1)
	weapon.AddAttribute("set item tint RGB", 15185211, -1)
	weapon.AddAttribute("energy weapon penetration", 1, -1)
	weapon.AddAttribute("energy weapon no deflect", 1, -1)
	weapon.AddAttribute("damage bonus", 4, -1)
	weapon.AddAttribute("Projectile speed increased", 4, -1)
}

::CW_Stats_GiantScoutSandman <- function(weapon, player)
{
    weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("effect bar recharge rate increased", 0.1, -1)
	weapon.AddAttribute("fire rate penalty", 0.7, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantDemoknight <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.85, -1)
	weapon.AddAttribute("damage penalty", 2, -1)
	weapon.AddAttribute("critboost on kill", 3, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantDemoknightShield <- function(weapon, player)
{
	if( weapon.ValidateScriptScope() )
	{

		local weaponscope = weapon.GetScriptScope()
		weaponscope["think_democharge"] <- function()	//Our script's name under the weapon scope.
		{
			local buttons = NetProps.GetPropInt(player, "m_nButtons");
			local chargeamount = NetProps.GetPropFloat(player, "m_Shared.m_flChargeMeter");
			if ((chargeamount >= 99) && ((buttons & 2048) == 2048))
			{
				player.AddCond(17)
			}
		}
		AddThinkToEnt(weapon, "think_democharge")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}
}

::CW_Stats_GiantDemomanRapidFire <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.15, -1)
	weapon.AddAttribute("faster reload rate", 0.15, -1)
	weapon.AddAttribute("blast radius increased", 1.25, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("auto fires full clip penalty", 2, -1)
	weapon.AddAttribute("auto fires when full", 2, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("clip size bonus", 5, -1)
	NetProps.SetPropIntArray(player, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 62.4375, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantDemoGlock <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.75, -1)
	weapon.AddAttribute("faster reload rate", 2, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("damage bonus", 2, -1)
}

::CW_Stats_GiantDemoSwitchBlade <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.75, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("damage bonus", 2, -1)
}

::CW_Stats_GiantHeavyFistsOfSteel <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 5, -1)
	weapon.AddAttribute("fire rate bonus", 0.6, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantHeavyShotgun <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 2.5, -1)
	weapon.AddAttribute("bullets per shot bonus", 10, -1)
	weapon.AddAttribute("faster reload rate", 0.1, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 31.21875, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantScoutHolyMackerel <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 2, -1)
	weapon.AddAttribute("dmg bonus vs buildings", 0.8, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantMedicCrossbow <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.4, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 26.28947368, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantMedicOverdose <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.6, -1)
	weapon.AddAttribute("faster reload rate", 2, -1)
	weapon.AddAttribute("damage penalty", 1.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("clip size bonus", 2.5, -1)
	NetProps.SetPropIntArray(player, "m_iClip1", 100, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 6.66, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantScoutPistol <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.5, -1)
	weapon.AddAttribute("faster reload rate", 1.5, -1)
	weapon.AddAttribute("weapon spread bonus", 0.4, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("dmg bonus vs buildings", 3, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
}

::CW_Stats_GiantSniperSMG <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("fire rate penalty", 0.85, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("clip size bonus", 2.4, -1)
	NetProps.SetPropIntArray(player, "m_iClip1", 60, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 13.32, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
}

::CW_Stats_GiantSniperHuntsman <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 0.8, -1)
	weapon.AddAttribute("fire rate penalty", 0.55, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 83.25, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantSoldierBison <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("SPELL: set item tint RGB", 4, -1)
	weapon.AddAttribute("energy weapon no deflect", 1, -1)
	weapon.AddAttribute("damage bonus", 4, -1)
	weapon.AddAttribute("Projectile speed increased", 4, -1)
	weapon.AddAttribute("crits_become_minicrits", 1, -1)
}

::CW_Stats_GiantSoldierRapidFire <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.15, -1)
	weapon.AddAttribute("faster reload rate", 0.15, -1)
	weapon.AddAttribute("blast radius increased", 1.25, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("auto fires full clip penalty", 2, -1)
	weapon.AddAttribute("auto fires when full", 2, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("crits_become_minicrits", 1, -1)
	weapon.AddAttribute("clip size bonus", 5, -1)
	NetProps.SetPropIntArray(player, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 49.95, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroScorchSpammer <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.4, -1)
	weapon.AddAttribute("faster reload rate", 0.4, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("projectile spread angle penalty", 7, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("dmg penalty vs nonburning", 0.25, -1)
	weapon.AddAttribute("damage bonus vs burning", 1.5, -1)
	weapon.AddAttribute("Blast radius increased", 1.5, -1)
	weapon.AddAttribute("crits_become_minicrits", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 62.4375, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantSpyRevolver <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.4, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("no crit boost", 1, -1)
	weapon.AddAttribute("crits_become_minicrits", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 41.625, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

RegisterCustomWeapon("GiantDemoknightShield", "Chargin' Targe",
		null,
		Defaults,
		function (table, player) {
			table.slot			= 1;		// The slot the script checks for before deleting and making our new weapon
		},
		CW_Stats_GiantDemoknightShield)

function SlappyReplace(weapon, player){
	weapon.SetSkin(1)
	weapon.SetDrawEnabled(false)
	AddThinkToEnt(weapon, "stopthathand")
}

RegisterCustomWeapon("RobotSlappingHand", "Hot Hand",
		null,
		Defaults,
		function (table, player) {
			table.worldModel = "models/empty.mdl"
			table.slot			= 2
		},SlappyReplace)


RegisterCustomWeapon("GiantDemoGlock", "pistol",
		22,
		Defaults,
		function (table, player) {
			table.slot			= 1
			table.classArms = GTFW_ARMS.ENGINEER;		//Adds Pyro arms model to all classes
			table.reserve		= 999
			table.reserveMax	= 999
			table.clipSize		= 20
			table.clipSizeMax	= 20
		},CW_Stats_GiantDemoGlock )